/*
THIS IS A GENERATED/BUNDLED FILE BY ESBUILD
if you want to view the source, please visit the github repository of this plugin
*/

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// main.ts
__export(exports, {
  FilePathModal: () => FilePathModal,
  default: () => RedirectPlugin
});
var import_obsidian = __toModule(require("obsidian"));
var imageExtensions = [
  "jpg",
  "jpeg",
  "jfif",
  "pjpeg",
  "pjp",
  "png",
  "svg",
  "webp",
  "apng",
  "avif",
  "gif",
  "bmp",
  "ico",
  "cur",
  "tif",
  "tiff"
];
var Mode;
(function(Mode2) {
  Mode2["RedirectOpen"] = "Open";
  Mode2["Standard"] = "Standard";
})(Mode || (Mode = {}));
var DEFAULT_SETTINGS = {
  limitToNonMarkdown: true,
  triggerString: "r[",
  mode: Mode.Standard,
  limitToRedirectedFiles: true,
  apiVersion: 2
};
var getRedirectFiles = (plugin, files, limitToRedirectedFiles, filterString) => {
  let redirectsGathered = files.map((file) => {
    var _a;
    const frontMatter = (_a = plugin.app.metadataCache.getFileCache(file)) == null ? void 0 : _a.frontmatter;
    let aliases = (frontMatter == null ? void 0 : frontMatter.alias) || (frontMatter == null ? void 0 : frontMatter.aliases) || [];
    if (!Array.isArray(aliases)) {
      aliases = aliases != null ? [aliases] : [];
    }
    aliases = aliases.filter((a) => a !== null && a !== void 0);
    let redirects = (frontMatter == null ? void 0 : frontMatter.redirects) || (frontMatter == null ? void 0 : frontMatter.redirect) || (limitToRedirectedFiles ? [] : [file.path]);
    if (!Array.isArray(redirects)) {
      redirects = redirects != null ? [redirects] : [];
    }
    redirects = redirects.filter((r) => r !== null && r !== void 0);
    let output = [
      ...Array.isArray(aliases) ? aliases : [aliases],
      file.basename
    ].map((alias) => {
      if (alias === "" || alias === void 0) {
        return null;
      }
      return [
        ...Array.isArray(redirects) ? redirects : [redirects]
      ].filter((o) => o !== null && o !== void 0).map((redirect) => {
        const redirectTFile = plugin.app.metadataCache.getFirstLinkpathDest(redirect, file.path);
        if (redirectTFile === null || redirectTFile === void 0) {
          return;
        }
        const embedPath = plugin.app.vault.getResourcePath(redirectTFile);
        return {
          alias: `${alias}`,
          path: `${redirect}`,
          originTFile: file,
          embedPath,
          isAlias: alias !== file.basename,
          extension: redirect.split(".").pop(),
          redirectTFile
        };
      });
    }).flat();
    output = output.filter((a) => {
      if (a === void 0 || a === null) {
        return false;
      }
      if (a.originTFile === a.redirectTFile) {
        return false;
      }
      if (a === void 0) {
        return false;
      }
      if (!filterString) {
        return true;
      }
      const queryWords = filterString.toLowerCase().split(/\s{1,}/);
      return queryWords.every((word) => {
        return a.alias.toLowerCase().contains(word) || a.path.toLowerCase().contains(word);
      });
    });
    return output;
  }).filter((a) => a.length).flat().filter((r) => r !== void 0 && r !== null);
  if (plugin.settings.limitToNonMarkdown) {
    redirectsGathered = redirectsGathered.filter((redirect) => (redirect == null ? void 0 : redirect.extension) && !(redirect.extension === "md"));
  }
  return redirectsGathered;
};
var renderSuggestionObject = (suggestion, el) => {
  const suggesterEl = el.createDiv({ cls: "redirect-suggester-el" });
  if (suggestion.isAlias) {
    const aliasEl = suggesterEl.createSpan();
    aliasEl.setText("\u293F");
    aliasEl.addClass("redirect-is-alias");
  }
  const suggestionTextEl = suggesterEl.createDiv({
    cls: "redirect-suggestion-text"
  });
  suggestionTextEl.createDiv({ cls: "redirect-alias" }).setText(suggestion.alias);
  suggestionTextEl.createDiv({ cls: "redirect-item" }).setText(suggestion.path);
  if (imageExtensions.contains(suggestion.extension)) {
    const imgContainerEl = suggesterEl.createDiv({
      cls: "redirect-suggestion-image-container"
    });
    const imgContainerSmallEl = imgContainerEl.createDiv({
      cls: "redirect-suggestion-image-container-small"
    });
    imgContainerSmallEl.style.backgroundImage = `url('${suggestion.embedPath}')`;
    const imgLargeEl = imgContainerEl.createEl("img");
    imgLargeEl.addClass("redirect-suggestion-image-large");
    imgLargeEl.setAttr("src", suggestion.embedPath);
    imgLargeEl.setAttr("alt", "");
  }
};
var handleFilesWithModal = (plugin, app2, files, ctrlKey) => {
  const redirectFiles = getRedirectFiles(plugin, app2.vault.getFiles(), plugin.settings.limitToRedirectedFiles);
  [...files].forEach((f) => {
    let filePath = f.path;
    if (f instanceof File) {
      const basePath = app2.vault.adapter.getBasePath();
      filePath = f.path.replace(basePath, "").replace(/^[\/\\]/, "").replace("\\", "/");
    }
    const relevantRedirectFiles = redirectFiles.filter((redirectFile) => {
      return redirectFile.redirectTFile.path === filePath;
    });
    const relevantRedirectFilesChunked = [
      ...new Set(relevantRedirectFiles.map((f2) => f2.originTFile.path))
    ];
    if ([...files].length === 1 && relevantRedirectFilesChunked.length === 1) {
      plugin.app.workspace.getLeaf(ctrlKey).openFile(relevantRedirectFiles[0].originTFile);
      return;
    }
    if (relevantRedirectFilesChunked.length >= 1) {
      const fileModal = new FilePathModal({
        app: plugin.app,
        fileOpener: true,
        onChooseFile: (file, newPane) => {
          plugin.app.workspace.getLeaf(newPane).openFile(file.originTFile);
        },
        limitToNonMarkdown: plugin.settings.limitToNonMarkdown,
        files: relevantRedirectFiles
      });
      fileModal.open();
    }
  });
};
var RedirectPlugin = class extends import_obsidian.Plugin {
  onload() {
    return __async(this, null, function* () {
      yield this.loadSettings();
      this.registerEditorSuggest(new RedirectEditorSuggester(this, this.settings));
      this.app.workspace.on("editor-drop", (evt, editor) => __async(this, null, function* () {
        if (evt.defaultPrevented) {
          return;
        }
        if (this.settings.mode !== Mode.RedirectOpen) {
          return;
        }
        if (!(this.app.vault.adapter instanceof import_obsidian.FileSystemAdapter)) {
          return;
        }
        evt.preventDefault();
        const basePath = this.app.vault.adapter.getBasePath();
        const files = [...evt.dataTransfer.files].filter((f) => f.path.startsWith(basePath));
        handleFilesWithModal(this, app, files, evt.ctrlKey);
      }));
      this.addCommand({
        id: "add-redirect-link",
        icon: "link",
        name: "Trigger redirected link",
        editorCallback: (editor, view) => {
          editor.replaceSelection(this.settings.triggerString);
        }
      });
      this.addCommand({
        id: "redirect-insert-file-path",
        icon: "pin",
        name: "Insert redirected file path",
        editorCallback: (editor) => {
          const fileModal = new FilePathModal({
            app: this.app,
            fileOpener: false,
            onChooseFile: (file) => {
              this.app.keymap;
              editor.replaceSelection(`"${file.path}"`);
            },
            limitToNonMarkdown: this.settings.limitToNonMarkdown,
            files: app.vault.getFiles().map((file) => {
              return {
                alias: `${file.name}`,
                path: `${file.path}`,
                originTFile: file,
                embedPath: this.app.vault.getResourcePath(file),
                isAlias: false,
                extension: file.extension,
                redirectTFile: file
              };
            })
          });
          fileModal.open();
        }
      });
      this.addCommand({
        id: "redirect-open-file",
        icon: "go-to-file",
        name: "Open file",
        callback: () => {
          const fileModal = new FilePathModal({
            app: this.app,
            fileOpener: true,
            onChooseFile: (file, newPane) => {
              this.app.workspace.getLeaf(newPane).openFile(file.redirectTFile);
            },
            limitToNonMarkdown: this.settings.limitToNonMarkdown,
            files: getRedirectFiles(this, app.vault.getFiles(), this.settings.limitToRedirectedFiles)
          });
          fileModal.open();
        }
      });
      this.addCommand({
        id: "redirect-open-origin-file",
        icon: "go-to-file",
        name: "Open origin file",
        callback: () => {
          const fileModal = new FilePathModal({
            app: this.app,
            fileOpener: true,
            onChooseFile: (file, newPane) => {
              this.app.workspace.getLeaf(newPane).openFile(file.originTFile);
            },
            limitToNonMarkdown: this.settings.limitToNonMarkdown,
            files: getRedirectFiles(this, app.vault.getFiles(), this.settings.limitToRedirectedFiles)
          });
          fileModal.open();
        }
      });
      this.addCommand({
        id: "redirect-open-current-file-origin",
        icon: "popup-open",
        name: "Open current file's origin file",
        checkCallback: (checking) => {
          const currentFile = this.app.workspace.getActiveFile();
          let redirectFiles = getRedirectFiles(this, app.vault.getFiles(), true).filter((a) => a.redirectTFile === currentFile);
          if (checking) {
            if (!redirectFiles.length) {
              return false;
            }
            return true;
          }
          const redirectFilesSet = [
            ...new Set(redirectFiles.map((a) => a.originTFile))
          ];
          if (redirectFilesSet.length === 1) {
            this.app.workspace.getLeaf(false).openFile(redirectFiles[0].originTFile);
            return;
          }
          if (redirectFilesSet.length > 1) {
            const fileModal = new FilePathModal({
              app: this.app,
              fileOpener: true,
              onChooseFile: (file, newPane) => {
                this.app.workspace.getLeaf(newPane).openFile(file.originTFile);
              },
              limitToNonMarkdown: this.settings.limitToNonMarkdown,
              files: redirectFiles
            });
            fileModal.open();
            return;
          }
        }
      });
      this.registerEvent(this.app.workspace.on(`file-menu`, (menu, file) => {
        if (file instanceof import_obsidian.TFile && (!this.settings.limitToNonMarkdown || this.settings.limitToNonMarkdown && file.extension !== "md")) {
          menu.addItem((item) => {
            item.setTitle("Open redirect origin file").setIcon("right-arrow-with-tail").onClick((e) => {
              handleFilesWithModal(this, app, [file], e.ctrlKey);
            });
          });
        }
      }));
      if (this.app.vault.adapter instanceof import_obsidian.FileSystemAdapter) {
        this.statusBar = this.addStatusBarItem();
        this.statusBar.setText(`Redirect drop: ${this.settings.mode}`);
        this.statusBar.onClickEvent(() => __async(this, null, function* () {
          this.settings.mode = this.settings.mode === Mode.Standard ? Mode.RedirectOpen : Mode.Standard;
          this.statusBar.setText(`Redirect drop: ${this.settings.mode}`);
          yield this.saveSettings();
        }));
        this.addCommand({
          id: "change-mode",
          icon: "switch",
          name: "Change mode",
          editorCallback: (editor, view) => __async(this, null, function* () {
            this.settings.mode = this.settings.mode === Mode.Standard ? Mode.RedirectOpen : Mode.Standard;
            this.statusBar.setText(`Redirect drop: ${this.settings.mode}`);
            yield this.saveSettings();
          })
        });
      }
      this.addSettingTab(new RedirectSettingsTab(this.app, this));
    });
  }
  onunload() {
  }
  loadSettings() {
    return __async(this, null, function* () {
      this.settings = Object.assign({}, DEFAULT_SETTINGS, yield this.loadData());
    });
  }
  saveSettings() {
    return __async(this, null, function* () {
      yield this.saveData(this.settings);
    });
  }
};
var FilePathModal = class extends import_obsidian.FuzzySuggestModal {
  constructor({
    app: app2,
    fileOpener,
    onChooseFile,
    limitToNonMarkdown,
    files
  }) {
    super(app2);
    this.files = files;
    const instructions = [
      { command: "\u2B81", purpose: "to navigate" },
      {
        command: "\u2936",
        purpose: "to open"
      },
      {
        command: "esc",
        purpose: "to dismiss"
      }
    ];
    if (fileOpener) {
      this.ctrlKeyHandler = this.scope.register(["Ctrl"], "Enter", (evt) => {
        this.chooser.useSelectedItem(evt);
        return false;
      });
      instructions.splice(2, 0, {
        command: "ctrl \u2936",
        purpose: "to open in new pane"
      });
    }
    this.setInstructions(instructions);
    if (limitToNonMarkdown) {
      this.files = this.files.filter((file) => !file.extension.endsWith("md"));
    }
    this.onChooseSuggestion = (item, evt) => {
      this.scope.unregister(this.ctrlKeyHandler);
      onChooseFile(item.item, evt.ctrlKey);
    };
  }
  getItems() {
    return this.files;
  }
  renderSuggestion(item, el) {
    renderSuggestionObject(item.item, el);
  }
  getItemText(item) {
    return `${item.path} ${item.alias} ${item.originTFile.path}`;
  }
};
var escapeRegExp = (str) => {
  return str.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
};
var RedirectEditorSuggester = class extends import_obsidian.EditorSuggest {
  constructor(plugin, settings) {
    super(plugin.app);
    this.plugin = plugin;
    this.settings = settings;
    this.triggerString = this.plugin.settings.triggerString;
  }
  onTrigger(cursor, editor, file) {
    var _a, _b;
    const line = editor.getLine(cursor.line);
    const subString = line.substring(0, cursor.ch);
    const match = (_a = subString.match(new RegExp(escapeRegExp(this.triggerString)))) == null ? void 0 : _a.first();
    const triggerStringClosingBrackets = (_b = this.triggerString.match(/\[{1,}$/)) == null ? void 0 : _b.first();
    if (match) {
      return {
        start: {
          ch: subString.lastIndexOf(match),
          line: cursor.line
        },
        end: {
          line: cursor.line,
          ch: triggerStringClosingBrackets && editor.getLine(cursor.line).length > cursor.ch && editor.getRange(cursor, {
            line: cursor.line,
            ch: cursor.ch + 1
          }) === "]".repeat(triggerStringClosingBrackets.length) ? cursor.ch + 1 : cursor.ch
        },
        query: subString.substring(subString.lastIndexOf(match) + this.triggerString.length, subString.length)
      };
    }
  }
  getSuggestions(context) {
    return getRedirectFiles(this.plugin, this.plugin.app.vault.getFiles(), this.plugin.settings.limitToRedirectedFiles, context.query);
  }
  renderSuggestion(suggestion, el) {
    renderSuggestionObject(suggestion, el);
  }
  selectSuggestion(suggestion) {
    if (this.context) {
      const file = this.plugin.app.metadataCache.getFirstLinkpathDest(suggestion.path, suggestion.originTFile.path);
      if (file) {
        const markdownLink = this.plugin.app.fileManager.generateMarkdownLink(file, this.plugin.app.workspace.getActiveFile().path, "", suggestion.alias).replace(/^\!/, "");
        const editor = this.context.editor;
        editor.replaceRange(markdownLink, this.context.start, this.context.end);
        const { ch, line } = this.context.start;
        editor.setCursor({ line, ch: ch + markdownLink.length });
      }
    }
  }
};
var RedirectSettingsTab = class extends import_obsidian.PluginSettingTab {
  constructor(app2, plugin) {
    super(app2, plugin);
    this.plugin = plugin;
  }
  display() {
    let { containerEl } = this;
    containerEl.empty();
    containerEl.createEl("h2", { text: "Redirect" });
    new import_obsidian.Setting(containerEl).setName("Limit to non-Markdown files").setDesc("Look for only non-Markdown files.").addToggle((toggle) => toggle.setValue(this.plugin.settings.limitToNonMarkdown).onChange((value) => __async(this, null, function* () {
      this.plugin.settings.limitToNonMarkdown = value;
      yield this.plugin.saveSettings();
    })));
    new import_obsidian.Setting(containerEl).setName("Limit to redirected files").setDesc(`Look for only files that are redirected. If this is off, all files in the Vault will be listed (subject to the "Limit to non-Markdown files" setting above), supplemented with a list of redirected files.`).addToggle((toggle) => toggle.setValue(this.plugin.settings.limitToRedirectedFiles).onChange((value) => __async(this, null, function* () {
      this.plugin.settings.limitToRedirectedFiles = value;
      yield this.plugin.saveSettings();
    })));
    new import_obsidian.Setting(containerEl).setName("Trigger string").setDesc('The string to trigger suggestions. Changing this setting requires reloading Obsidian. Triggering may not work if this string conflicts with an existing trigger (e.g., "[[").').addText((text) => text.setValue(this.plugin.settings.triggerString || DEFAULT_SETTINGS.triggerString).setPlaceholder(DEFAULT_SETTINGS.triggerString).onChange((value) => __async(this, null, function* () {
      this.plugin.settings.triggerString = value || DEFAULT_SETTINGS.triggerString;
      yield this.plugin.saveSettings();
    })));
  }
};
